SystemOrganization addCategory: #MEG!

Object subclass: #HomeSiteCriteria
	instanceVariableNames: 'name type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG'!

!HomeSiteCriteria class methodsFor: 'instance creation' stamp: 'SergioFedi 6/6/2016 11:39'!
named: aString

	^self new 
		name: aString;
		yourself.! !

!HomeSiteCriteria class methodsFor: 'instance-creation' stamp: 'SergioFedi 6/6/2016 11:40'!
type: aString

	^self new
		type: aString;
		yourself.! !

!HomeSiteCriteria methodsFor: 'private' stamp: 'SergioFedi 6/6/2016 11:39'!
name: aString

	name := aString.! !

!HomeSiteCriteria methodsFor: 'private' stamp: 'SergioFedi 6/6/2016 11:41'!
type: aString

	type := aString.! !

Object subclass: #MEGEntity
	instanceVariableNames: 'name followers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG'!

MEGEntity subclass: #MEGAgent
	instanceVariableNames: 'currentGeneralInfluence'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG'!

!MEGAgent class methodsFor: 'instance creation' stamp: 'SergioFedi 6/6/2016 10:29'!
named: aString

	^self new 
		name: aString;
		yourself.! !

!MEGAgent methodsFor: 'public' stamp: 'SergioFedi 6/6/2016 11:25'!
currentGeneralInfluence

	^currentGeneralInfluence.! !

!MEGAgent methodsFor: 'initialization' stamp: 'SergioFedi 6/6/2016 11:25'!
initialize

	super initialize.
	currentGeneralInfluence := 20.! !

MEGEntity subclass: #MEGCharacter
	instanceVariableNames: 'homeSiteCriteria companies characterFollowed currentSite world'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG'!

!MEGCharacter class methodsFor: 'instance creation' stamp: 'SergioFedi 5/26/2016 09:08'!
named: aString homeSiteNamed: siteName

	^self new
		name: aString;
		homeSiteCriteria: (HomeSiteCriteria named: siteName);
		yourself.! !

!MEGCharacter class methodsFor: 'instance creation' stamp: 'SergioFedi 5/26/2016 09:02'!
named: aString homeSiteType: homeSiteTypeString

	^self new
		name: aString;
		homeSiteCriteria: (HomeSiteCriteria type: homeSiteTypeString);
		yourself.! !

!MEGCharacter methodsFor: 'public' stamp: 'FedericoFigueredo 6/2/2016 08:24'!
characterFollowed
	^ characterFollowed.! !

!MEGCharacter methodsFor: 'private' stamp: 'FedericoFigueredo 6/2/2016 09:16'!
characterFollowed: aMEGCharacter 
	characterFollowed := aMEGCharacter.! !

!MEGCharacter methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 23:46'!
companies

	^companies.! !

!MEGCharacter methodsFor: 'public' stamp: 'FedericoFigueredo 6/2/2016 08:26'!
currentSite
	^ currentSite.! !

!MEGCharacter methodsFor: 'private' stamp: 'FedericoFigueredo 6/2/2016 09:16'!
currentSite: aMEGSite 
	currentSite := aMEGSite.! !

!MEGCharacter methodsFor: 'private' stamp: 'SergioFedi 5/26/2016 08:55'!
homeSiteCriteria
	^ homeSiteCriteria! !

!MEGCharacter methodsFor: 'private' stamp: 'SergioFedi 5/26/2016 08:55'!
homeSiteCriteria: anObject
	homeSiteCriteria := anObject! !

!MEGCharacter methodsFor: 'initialization' stamp: 'SergioFedi 6/6/2016 11:23'!
initialize

	super initialize.

	companies := OrderedCollection new.
	homeSiteCriteria := nil.
! !

!MEGCharacter methodsFor: 'private' stamp: 'FedericoFigueredo 6/2/2016 08:55'!
newRecruitAction
	^ MEGRecruitCharacterAction world: self world.! !

!MEGCharacter methodsFor: 'public' stamp: 'FedericoFigueredo 6/2/2016 08:56'!
recruit: aMEGCharacter at: aMEGSite
	 
	| action |
	action := self newRecruitAction.
	
	action recruiter: self.
	action recruitee: aMEGCharacter.
	action site: aMEGSite.
	
	action perform.! !

!MEGCharacter methodsFor: 'public' stamp: 'FedericoFigueredo 6/2/2016 08:53'!
world
	^ world! !

!MEGCharacter methodsFor: 'private' stamp: 'FedericoFigueredo 6/2/2016 08:53'!
world: anObject
	world := anObject! !

!MEGEntity methodsFor: 'public' stamp: 'SergioFedi 6/6/2016 11:21'!
followers
	^ followers.! !

!MEGEntity methodsFor: 'initialization' stamp: 'SergioFedi 6/6/2016 11:23'!
initialize

	super initialize.

	followers := OrderedCollection new.
	name := nil.
! !

!MEGEntity methodsFor: 'private' stamp: 'SergioFedi 6/6/2016 11:21'!
name

	^name.! !

!MEGEntity methodsFor: 'private' stamp: 'SergioFedi 6/6/2016 11:21'!
name: aString

	name := aString.! !

Object subclass: #MEGRecruitCharacterAction
	instanceVariableNames: 'recruiter recruitee world site'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG'!

!MEGRecruitCharacterAction class methodsFor: 'instance creation' stamp: 'FedericoFigueredo 6/2/2016 09:01'!
world: aMEGWorld 
	^ self new
		world: aMEGWorld;
		yourself.! !

!MEGRecruitCharacterAction methodsFor: 'public' stamp: 'FedericoFigueredo 6/2/2016 09:14'!
perform
	"establecerRelacionReclutadorReclutado"
	self recruiter followers add: recruitee.
	self recruitee characterFollowed: self recruiter.
	"meterReclutadoEnLocation"
	self recruitee currentSite: self site.
	self site occupants add: self recruitee.! !

!MEGRecruitCharacterAction methodsFor: 'public' stamp: 'FedericoFigueredo 6/2/2016 08:57'!
recruitee
	^ recruitee! !

!MEGRecruitCharacterAction methodsFor: 'public' stamp: 'FedericoFigueredo 6/2/2016 08:57'!
recruitee: anObject
	recruitee := anObject! !

!MEGRecruitCharacterAction methodsFor: 'public' stamp: 'FedericoFigueredo 6/2/2016 08:57'!
recruiter
	^ recruiter! !

!MEGRecruitCharacterAction methodsFor: 'public' stamp: 'FedericoFigueredo 6/2/2016 08:57'!
recruiter: anObject
	recruiter := anObject! !

!MEGRecruitCharacterAction methodsFor: 'public' stamp: 'FedericoFigueredo 6/2/2016 08:58'!
site
	^ site! !

!MEGRecruitCharacterAction methodsFor: 'public' stamp: 'FedericoFigueredo 6/2/2016 08:58'!
site: anObject
	site := anObject! !

!MEGRecruitCharacterAction methodsFor: 'public' stamp: 'FedericoFigueredo 6/2/2016 08:58'!
world
	^ world! !

!MEGRecruitCharacterAction methodsFor: 'public' stamp: 'FedericoFigueredo 6/2/2016 08:58'!
world: anObject
	world := anObject! !

Object subclass: #MEGSite
	instanceVariableNames: 'name occupants'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG'!

!MEGSite class methodsFor: 'instance creation' stamp: 'SergioFedi 5/26/2016 08:51'!
named: aString

	^self new name: aString.! !

!MEGSite methodsFor: 'private' stamp: 'FedericoFigueredo 6/2/2016 08:36'!
initialize
	super initialize.
	occupants := OrderedCollection new.! !

!MEGSite methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 08:51'!
name
	^ name! !

!MEGSite methodsFor: 'private' stamp: 'SergioFedi 5/26/2016 08:50'!
name: anObject
	name := anObject! !

!MEGSite methodsFor: 'public' stamp: 'FedericoFigueredo 6/2/2016 08:34'!
occupants
	^ occupants.! !

Object subclass: #MEGWorld
	instanceVariableNames: 'locations characters agents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MEG'!

!MEGWorld methodsFor: 'public' stamp: 'SergioFedi 6/6/2016 10:30'!
addAgent: aMEGAgent

	self agents add: aMEGAgent.! !

!MEGWorld methodsFor: 'public' stamp: 'FedericoFigueredo 6/2/2016 08:56'!
addCharacter: aMEGCharacter

	aMEGCharacter world: self.
	characters add: aMEGCharacter.! !

!MEGWorld methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 09:11'!
addSite: aMEGSite

	locations add: aMEGSite.! !

!MEGWorld methodsFor: 'public' stamp: 'SergioFedi 6/6/2016 10:32'!
agentNamed: aString

	^self agents detect: [:each | each name = aString].! !

!MEGWorld methodsFor: 'private' stamp: 'SergioFedi 6/6/2016 10:31'!
agents

	^agents.! !

!MEGWorld methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 23:44'!
characterNamed: aString

	^self characters detect: [:char | char name = aString].! !

!MEGWorld methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 08:32'!
characters
	^ characters! !

!MEGWorld methodsFor: 'initialization' stamp: 'SergioFedi 6/6/2016 10:31'!
initialize

	super initialize.

	characters := OrderedCollection new.
	locations := OrderedCollection new.
	agents := OrderedCollection new.! !

!MEGWorld methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 08:32'!
locations

	^locations.! !

!MEGWorld methodsFor: 'public' stamp: 'SergioFedi 5/26/2016 23:40'!
siteNamed: aString

	^self locations detect: [:site | site name = aString].! !
